
import java.io.IOException;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import javax.microedition.midlet.MIDlet;
import java.io.*;

public class ClmNetwork implements Runnable {

 private String url;
 private ClmEngine moteur;
 private StringItem statusField;
 private String userAgent;
 private String titre;
 
 public ClmNetwork(ClmEngine moteur, String userAgent, StringItem statusField, String titre) throws IOException {
    this.titre = titre;
   this.url = moteur.getExportURL();
   this.moteur = moteur;
   this.statusField = statusField;
   this.userAgent = userAgent;
   Thread t = new Thread(this);
   t.start();
 }

 public void run() {
   try { 
     postViaHttpConnection(url);
   } catch (IOException ie) {
    // do nothing
   }
 }

  void postViaHttpConnection(String url) throws IOException {
        HttpConnection c = null;
        InputStream is = null;
        OutputStream os = null;
        int rc;
        String msgToSend = "";
        msgToSend += "exportName="+titre; 
        msgToSend += "&pseudo="+moteur.getPseudo();
        msgToSend += "&lapDistance="+moteur.getLapDistance();
        msgToSend += "&fullDistance="+moteur.getFullDistance();
        msgToSend += "&laps="+moteur._laps.toString();
        
        try {
            c = (HttpConnection)Connector.open(url);
            statusField.setText("Connected");
            // Set the request method and headers
            c.setRequestMethod(HttpConnection.POST);
            c.setRequestProperty("User-Agent", userAgent);
            c.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
            c.setRequestProperty("Content-Length", "" + msgToSend.length() );

            // Getting the output stream may flush the headers
            os = c.openOutputStream();
            os.write((msgToSend+"\n").getBytes());
            os.flush();           // Optional, getResponseCode will flush

            // Getting the response code will open the connection,
            // send the request, and read the HTTP response headers.
            // The headers are stored until requested.
            rc = c.getResponseCode();
            String responseMsg = (c.getResponseMessage()!=null)?c.getResponseMessage():"";
            if (rc != HttpConnection.HTTP_OK) {
                statusField.setText(responseMsg+" ("+rc+")");
                throw new IOException("HTTP response code: " + rc);
            }
            statusField.setText(responseMsg);

/*
            is = c.openInputStream();

            // Get the ContentType
            String type = c.getType();
            System.out.println(type);

            // Get the length and process the data
            int len = (int)c.getLength();
            if (len > 0) {
                 int actual = 0;
                 int bytesread = 0 ;
                 byte[] data = new byte[len];
                 while ((bytesread != len) && (actual != -1)) {
                    actual = is.read(data, bytesread, len - bytesread);
                    bytesread += actual;
                 }
                System.out.println(data);
            } else {
                int ch;
                while ((ch = is.read()) != -1) {
                    System.out.println((byte)ch);
                }
            }
*/
          
        } catch (ClassCastException e) {
          statusField.setText(e.getMessage());
          throw new IllegalArgumentException("Not an HTTP URL");
        } catch (Exception e) {
          statusField.setText(e.getMessage());
        } finally {
            if (is != null)
                is.close();
            if (os != null)
                os.close();
            if (c != null)
                c.close();
        }
    }

}
